include:
  remote: https://gitlab.com/pantacor/ci/container-ci/raw/master/yml/build-dockerfile.yml

image: docker:stable

services:
  - docker:dind

variables:
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
  DOCKER_DRIVER: overlay2
  GIT_SUBMODULE_STRATEGY: recursive

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  - docker run --rm --privileged multiarch/qemu-user-static:register || true
  - mkdir tmp
  - wget -O tmp/qemu-arm-static https://github.com/multiarch/qemu-user-static/releases/download/v2.12.0-1/qemu-arm-static
  - chmod a+x tmp/qemu-arm-static

build-amd64:
  stage: build
  script:
    - arch=amd64
    - tagname="$arch-$CI_COMMIT_REF_SLUG"
    - if [ "$CI_COMMIT_REF_SLUG" = "master" ]; then tagname=$arch; fi
    - "echo TAGNAME: $tagname   ARCH: $arch"
    - docker build --no-cache -t $CONTAINER_IMAGE:$tagname -f Dockerfile.$arch .
    - docker tag $CONTAINER_IMAGE:$tagname $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - test -n "$CI_COMMIT_TAG" && docker tag $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker push $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - docker push $CONTAINER_IMAGE:$tagname
    - test -n "$CI_COMMIT_TAG" && docker push $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true

build-arm32v7:
  stage: build
  script:
    - arch=arm32v7
    - tagname="$arch-$CI_COMMIT_REF_SLUG"
    - if [ "$CI_COMMIT_REF_SLUG" = "master" ]; then tagname=$arch; fi
    - "echo TAGNAME: $tagname   ARCH: $arch"
    - docker build --no-cache -t $CONTAINER_IMAGE:$tagname -f Dockerfile.$arch .
    - docker tag $CONTAINER_IMAGE:$tagname $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - test -n "$CI_COMMIT_TAG" && docker tag $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker push $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - docker push $CONTAINER_IMAGE:$tagname
    - test -n "$CI_COMMIT_TAG" && docker push $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true

build-arm32v5:
  stage: build
  script:
    - arch=arm32v5
    - tagname=$arch-$CI_COMMIT_REF_SLUG
    - if [ "$CI_COMMIT_REF_SLUG" = "master" ]; then tagname=$arch; fi
    - "echo TAGNAME: $tagname   ARCH: $arch"
    - docker build --no-cache -t $CONTAINER_IMAGE:$tagname -f Dockerfile.$arch .
    - docker tag $CONTAINER_IMAGE:$tagname $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - test -n "$CI_COMMIT_TAG" && docker tag $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker push $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - docker push $CONTAINER_IMAGE:$tagname
    - test -n "$CI_COMMIT_TAG" && docker push $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true

build-arm64v8:
  stage: build
  script:
    - arch=arm64v8
    - tagname=$arch-$CI_COMMIT_REF_SLUG
    - if [ "$CI_COMMIT_REF_SLUG" = "master" ]; then tagname=$arch; fi
    - "echo TAGNAME: $tagname   ARCH: $arch"
    - docker build --no-cache -t $CONTAINER_IMAGE:$tagname -f Dockerfile.$arch .
    - docker tag $CONTAINER_IMAGE:$tagname $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - test -n "$CI_COMMIT_TAG" && docker tag $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker push $CONTAINER_IMAGE:$tagname-$CI_COMMIT_SHA
    - docker push $CONTAINER_IMAGE:$tagname
    - test -n "$CI_COMMIT_TAG" && docker push $CONTAINER_IMAGE:$arch-$CI_COMMIT_TAG || true

package-build-amd64:
  extends: .package-build
  variables:
    ARCH: "amd64"
    PLATFORM: "linux/amd64"

package-build-arm32v5:
  extends: .package-build
  variables:
    ARCH: "arm32v5"
    PLATFORM: "linux/arm/v5"

package-build-arm32v7:
  extends: .package-build
  variables:
    ARCH: "arm32v7"
    PLATFORM: "linux/arm/v7"

package-build-arm64v8:
  extends: .package-build
  variables:
    ARCH: "arm64v8"
    PLATFORM: "linux/arm64"

